//--------------------------------------------------------------------

#include "Headers/SelectFunc.H"

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	MessageBox (GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Working_File)fclose(Working_File);
	if(CypherTemp_File)fclose(CypherTemp_File);
	if(EncryptTemp_File)fclose(EncryptTemp_File);

	if(Source_File)fclose(Source_File);
	if(Target_File)fclose(Target_File);

	if(Delete)
	{
		unlink(EncryptTemp);
		unlink(PackBackupTemp);
	}

	if(Kill)
	{
		unlink(EncryptTemp);
		unlink(PackBackupTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int Encrypted(char *FileToCheck)
{
	static FILE * FileToCheck_File;

	if(FileToCheck_File)fclose(FileToCheck_File);

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 2.");

	static char Buffer[BufferSize*2];
	Buffer[0] = '\0';

	fread(Buffer,sizeof(char),10,FileToCheck_File);

	if(strcmp(Buffer,"Encrypted~") == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 1;
	}

	if(strcmp(Buffer,"128Packed~") == 0)
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		End_Of_File = 0;
		return 2;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 3;
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables()
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"Encrypt.128G");
	sprintf(PackBackupTemp,"%s\\%s",GetTempDirectory(),"PackBackup.128G");
	if(!EncryptTemp)
		return 1;
	if(!PackBackupTemp)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int CharInt(char *string2convert)
{
	int i, lenght_string;
	int power;
	int tmp_number;
	char tmp_char;
	if (!string2convert)
	{
		string2convert = "0";
		Error("Character To Interger Conversion Error. Error: 3.");
		return -1;
	}
	lenght_string = strlen(string2convert);
	for(i = 0; i < (lenght_string / 2); i++)
	{
		tmp_char = string2convert[i];
		string2convert[i] = string2convert[lenght_string - 1 - i];
		string2convert[lenght_string - 1 - i] = tmp_char;
	}
	power = 1;
	i = 0;
	tmp_number = 0;
	while (string2convert[i] != '\0')
	{
		tmp_number += (string2convert[i] - '0') * power;
		power *= 10;
		i++;
	}
	return tmp_number;
}

/////////////////////////////////////////////////////////////////////

extern char *StringScan (char *S, int length1, int length2)
{
	static int LocalLoop1;
	static int LocalLoop2;
	static char StrFunction[64][257];
	static int StrCnt;
	LocalLoop1 = 0;
	LocalLoop2 = 0;
	while(LocalLoop1 < 64)
	{
		while(LocalLoop2 < 257)
		{
			StrFunction[LocalLoop1][LocalLoop2] = '\0';
			LocalLoop2++;
		}
		LocalLoop1++;
	}
	if(++StrCnt==64) StrCnt = 0;
	strncpy(StrFunction[StrCnt], &S[length1], length2);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char T [257];
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	static short LocalLoop;
	static int StrCnt;
	static int T;
	static char xBuffer[2048];
	LPSTR StrFunc [16];
	LocalLoop = 0;
	StrCnt = 0;
	while(LocalLoop < 16)
	{
		StrFunc[LocalLoop] = '\0';
		LocalLoop++;
	}
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static	RECT  wRect;
	static	DWORD  x;
	static	DWORD  y;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern short FileEmpty(char *File2Size)
{
	FILE *fp;
	static short size;
	size = 0;

	if((fp = fopen(File2Size,"r+b")) == NULL)
	{
		Error("Could Not Open Source For Read. Error 4.");
		return 0;
	}

	while(!feof(fp))
	{
		fgetc(fp);
		if(!feof(fp))
		{
			size++;
		}

		if(size > 0)
		{
			if(fp)fclose(fp);
			return 0;
		}

		if(ferror(fp))
		{
			Error("Error Sizing File. Error 5.");
			return 0;
		}
	}

	if(fp)fclose(fp);
	if(size == 0)return 1;
	return 0;
}

/////////////////////////////////////////////////////////////////////

extern char *CreateKey(void)
{
	static char xCodedKey[27];
	sprintf(xCodedKey,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",49,50,56,71,97,109,109,97,126,69,110,99,114,121,112,116,101,100);
	return xCodedKey;
}

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{
	static short ENCMethod;
	ENCMethod = 0;
	ENCMethod = Encrypted(F);
	CleanUp(0,1);

	if(ENCMethod == 1) // Encrypted
	{
		MessageBox (0, "The File You Are Trying To Encrypt Is Already Encrypted!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 2) // Packed
	{
		MessageBox (0, "The File You Are Trying To Encrypt Is Already Packed!" ,TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 3) // NOT Encrypted
	{
		/* EnCode(Source,Target,Password); */
		if(EnCode(F,EncryptTemp,GetText(PasswordEdit_hWnd)))
		{
			/* IncodeMain(Source,Target); */
			if(IncodeMain(EncryptTemp,F) == 0)
			{
				if(IsDlgButtonChecked(PasswordDialog_hWnd,105))
				{
					static short DeleteLoop;
					DeleteLoop = 0;

					while(DeleteLoop < Number_Of_Files)
					{
						DeleteLoop++;
						unlink(FileArray[DeleteLoop]);
					}
				}
				MessageBox (0, "The File Was Successfully Encrypted." , TitleCaption, 0 + MB_ICONASTERISK);
			}
		}
		CleanUp(0,1);
		return(0);
	}

	CleanUp(0,1);
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	static short ENCMethod;
	ENCMethod = 0;
	ENCMethod = Encrypted(F);
	CleanUp(0,1);

	if(ENCMethod == 1) // Encrypted
	{
		if(DecodeMain(F,EncryptTemp) == 0)
		{
			if(DeCode(EncryptTemp,F,GetText(PasswordEdit_hWnd)) == 0)
			{
				MessageBox (0, "The File Was Successfully Decrypted." , TitleCaption, 0 + MB_ICONASTERISK);
			}
		}
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 2) //  Packed
	{
		static char xPath[257];
		static char xDrive[11];

		xPath[0] = '\0';
		xDrive[0] = '\0';

		static char SourceFilePath[257];
		/* Split Drive And Path Of SourceFileName And Set Then To (SourceFilePath) */

		_splitpath(F,xDrive,xPath,NULL,NULL);
		sprintf(SourceFilePath,"%s%s",xDrive,xPath);

		if(DecodeMain(F,EncryptTemp) == 0)
		{
			if(DeCode(EncryptTemp,PackBackupTemp,GetText(PasswordEdit_hWnd)) == 0)
			{
				if(UnPackFiles(PackBackupTemp,SourceFilePath))
				{
					MessageBox(0, "The File Was Successfully UnPacked." , TitleCaption, 0 + MB_ICONASTERISK);
					CleanUp(0,1);
				}
			}
		}
		CleanUp(0,1);
		return(0);
	}

	if(ENCMethod == 3) // NOT Encrypted
	{
		MessageBox (0, "The File You Are Trying To Decrypt Is Not Encrypted!" , TitleCaption, 0 + MB_ICONASTERISK);
		CleanUp(0,1);
		return(0);
	}

	CleanUp(0,1);
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	static short ENCMethod;
	ENCMethod = 0;
	//	  ENCMethod = Encrypted(F);
	/* ENCMethod ( 1 = Encrypted , 2 = Packed , 3 = NOT Encrypted) */

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		static char Extention[257];
		Extention[0] = '\0';
		_splitpath(xInput,NULL,NULL,NULL,Extention);

		if(FileEmpty(xInput) && (strcmp(Extention,".128") == 0) )
		{
			Clear_FileArray();
			Clear_FileSizeArray();
			Clear_ScanTemp();
			Clear_FileSizeArray_Temp();
			FileArray[0] = "*";

			if(PackFiles(xInput))
			{
				sprintf(F,"%s",xInput);
				MethodFlag = PACFlag;
				Encrypt = 1;
				Decrypt = 0;
				DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			}

			CleanUp(0,1);
			return(0);
		}

		MethodFlag = ENCFlag;
		sprintf(F,"%s",xInput);
		ENCMethod = Encrypted(F);

		if(ENCMethod == 1) // Encrypted
		{
			Encrypt = 0;
			Decrypt = 1;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);

		}

		if(ENCMethod == 2) //  Packed
		{
			Encrypt = 0;
			Decrypt = 1;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);

		}

		if(ENCMethod == 3) // NOT Encrypted
		{
			Encrypt = 1;
			Decrypt = 0;
			ENCMethod = 0;
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			ENCMethod = 0;
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);
	return 1;
}

/////////////////////////////////////////////////////////////////////

